unit K_MeansMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.StdCtrls, Vcl.ExtCtrls, system.Math,
  system.UITypes, Vcl.Grids;

type
  D2array = array of array of Double;
  B2array = array of array of array of Byte;

  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    KMeansBtn: TButton;
    FileSaveBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    Timer1: TTimer;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    ScrollBox2: TScrollBox;
    Image2: TImage;
    KNoEdit: TLabeledEdit;
    ScaleEdit: TLabeledEdit;
    ScaleDisBtn: TButton;
    RepeatEdit: TLabeledEdit;
    MReset: TButton;
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure KMeansBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ScaleDisBtnClick(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure MResetClick(Sender: TObject);
    procedure Image1MouseEnter(Sender: TObject);
    procedure KNoEditChange(Sender: TObject);
  private
    { Private 錾 }
    procedure Imageout(Image: TBitmap; ImageNo: integer; magnification: double);
    procedure KMeans;
    function  dis(Ynow, Xnow: double; Y, X: integer): double;
    procedure KMarks;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
type
  Tcluster = record                           // NX^[R[h
    now_x, now_y: double;                     // NX^[ʒu x, y
    no          : integer;                    // f[^[_JE^[
    new_x, new_y: double;                     // X,YWlv
  end;

  TPrgbarry = array[0..0] of Trgbtriple;      // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray  = ^TPrgbarry;                    // |C^[

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHWC   = 440;    // \gTCY

  Laplacian     = 0;
  Gaussians     = 1;
  Deconvolution = 2;
  Unsharp       = 3;

var
  InputDBitmap  : TBitmap;                    // ̓f[^[\prbg}bv
  OutputBitmap  : TBitmap;                    // o͉摜\prbg}bv
  GHeight       : Integer;                    // ̓f[^[摜
  GWidth        : Integer;                    // ̓f[^[摜

  VRect         : Trect;                      // \TCYݒp
  InFilename    : string;                     // ̓t@C
  ColorMat      : array of array of byte;     // lf[^[摜p
  OutMat        : B2array;                    // vZʉ摜o͗pz
  RepeatF       : Boolean;                    // JԂvZtO
  K             : integer;
  cluster       : array of Tcluster;          // NX^[pz
  Scale         : double;
  DidScale      : double;
  MSetF         : smallint;
  YPos, Xpos    : Integer;
  Ino           : Integer;

//-------------------------------------
// }EXɂNX^[̏ʒuݒ
// MSetF = -3 }EXɂʒuݒ
// MSetF = -2 ς
// MSetF = 0  }EXɂݒI
//-------------------------------------
procedure TForm1.Image1DblClick(Sender: TObject);
var
  X, Y, I: Integer;
begin
  if MSetF = -3 then begin
  // 
    if not RepeatF then begin
      val(KnoEdit.Text, K, X);
      if X <> 0 then begin
        Application.MessageBox('NX^̓͒lɌ肪܂B','NX^', 0);
        exit;
      end;
      if (K < 2) or (K > 6) then begin
        Application.MessageBox('NX^͈̔͂͂QUłB','NX^', 0);
        exit;
      end;
      // f[^[ƃNX^[̊mF
      I := 0;
      for Y := 0 to GHeight - 1 do
        for X := 0 To GWidth - 1 do
          if ColorMat[Y, X] <> 0 then inc(I);
      if K > I then begin
        Application.MessageBox('NX^f[^[葽łB','NX^', 0);
        exit;
      end;
      setlength(cluster, K);
      // NX^̏ݒ
      for I := 0 to K -1 do begin
        cluster[I].no    := 0;
        cluster[I].new_y := 0;
        cluster[I].new_x := 0;
      end;
    end;
    MSetF := -2;
    Ino := 0;
  end;
  if (MSetF = -2) then begin
    // ʒuݒ
    cluster[Ino].now_y := round(YPos * DidScale);
    cluster[Ino].now_x := round(XPos * DidScale);
    inc(Ino);
    // ʒuݒI
    if Ino = K then begin
      RepeatF := True;
      MSetF := 0;
      Image1.Hint := 'NX^[ʒuݒς݂łB';
    end;
    // ʒu\
    Image1.Canvas.Pen.Color := clBlack;
    Image1.Canvas.Brush.Style := bsSolid;
    Image1.Canvas.Brush.Color := clBlack;
    Image1.Canvas.Ellipse(XPos - 5, YPos - 5, XPos + 5, YPos +5);
  end;
end;

//-------------------
// qg\ݒ
//-------------------
procedure TForm1.Image1MouseEnter(Sender: TObject);
begin
  if MSetF < 0 then Image1.Hint := '_uNbNŃNX^[ʒuZbg܂B';
  if MSetF = 0 then Image1.Hint := 'NX^[ʒuݒς݂łB';
end;

//---------------------
// }EẌʒu̎擾
//---------------------
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Ypos := Y;
  Xpos := X;
end;

//------------------------
// 摜f[^[̕ϔ{o
//------------------------
procedure TForm1.Imageout(Image: TBitmap; ImageNo: integer; magnification: double);
var
  Rect0           : Trect;
  MW, MH          : Integer;
begin
  MW := Round(GWidth * magnification);
  MH := Round(GHeight * magnification);
  Rect0 := Rect(0, 0, MW, MH);
  if ImageNo = 1 then begin
    Image1.Width := MW;
    Image1.Height := MH;
    Image1.Picture.Bitmap.SetSize(MW, MH);
    Image1.Canvas.StretchDraw(Rect0, Image);                // o͘gɕϔ{o
  end;
  if ImageNo = 2 then begin
    Image2.Width := MW;
    Image2.Height := MH;
    Image2.Picture.Bitmap.SetSize(MW, MH);
    Image2.Canvas.StretchDraw(Rect0, Image);                // o͘gɕϔ{o
  end;
end;

//--------------------------------------
// tB^[vZ^C}[x
// {^̕\؂ւVCLs̎ԑ҂
//--------------------------------------
procedure TForm1.KMeansBtnClick(Sender: TObject);
begin
  FileOpenBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
  Timer1.Enabled := True;
end;

//----------------------------------
// NX^[ύXZbg
//----------------------------------
procedure TForm1.KNoEditChange(Sender: TObject);
begin
  MResetClick(nil);
end;

//---------------------------------------------
// }EXɂZbgNX^[̈ʒu
//---------------------------------------------
procedure TForm1.MResetClick(Sender: TObject);
begin
  MSetF := -3;
  RepeatF := False;
  Imageout(InputDBitmap, 1, scale);                           // o͘gɕϔ{o
end;

//---------------------------------------------------
// ϔ{ύXĕ\
// }EXZbgɂ鏉ʒu͍ĕ\܂
//---------------------------------------------------
procedure TForm1.ScaleDisBtnClick(Sender: TObject);
var
  C: integer;
begin
  val(ScaleEdit.Text, scale, C);
  if C <> 0 then begin
    Application.MessageBox('\{̒lɊԈႢ܂B','\{', 0);
    exit;
  end;
  if scale <= 0 then begin
    Application.MessageBox('\{̒lɊԈႢ܂B','\{', 0);
    exit;
  end;
  Imageout(OutputBitmap, 2, Scale);                           // o͘gɕϔ{o
  Imageout(InputDBitmap, 1, scale);                           // o͘gɕϔ{o
  if RepeatF then KMarks;
end;

//--------------------------------------------
// ^C}[ɂxX^[g
//--------------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  KMeans;
  FileSaveBtn.Enabled := True;
  FileOpenBtn.Enabled := True;
end;

//--------------------------
// vZ܂
//--------------------------
function  TForm1.dis(Ynow, Xnow: double; Y, X: integer): double;
begin
  // ̔rȂ̂Ń[gJKvȂ
  result := (Y - Ynow) * (Y - Ynow) + (X - Xnow) * (X - Xnow);
//  result := sqrt((Y - Ynow) * (Y - Ynow) + (X - Xnow) * (X - Xnow));
end;

//-----------------------
// NX^[ە\
//-----------------------
procedure TForm1.KMarks;
var
  X, Y, I : integer;
begin
  for I := 0 to K -1 do begin
    Y := round(cluster[I].now_Y * scale);
    X := round(cluster[I].now_X * scale);
    Image2.Canvas.Pen.Color := clBlack;
    Image2.Canvas.Brush.Style := bsSolid;
    Image2.Canvas.Brush.Color := clBlack;
    Image2.Canvas.Ellipse(X - 5, Y - 5, X + 5, Y +5);
  end;
end;

//-------------------------------------
// NX^[
// NX^[̐F
// SetCl[I] = -2  ʒuĐݒ薢
// SetCl[I] = -1  ʒuݒJn
// SetCl[I] > -1  ʒuݒς
//-------------------------------------
procedure TForm1.KMeans;
var
  X, Y    : integer;
  I, IM   : integer;
  Loop    : integer;
  MinLeng : double;
  MinPos  : Byte;
  nowLeng : double;
  PB      : Prgbarray;
  ReNo    : integer;
  SetCl   : array of Integer;
  SetClF  : Boolean;
begin
  // 
  if not RepeatF then begin
    val(KnoEdit.Text, K, X);
    if X <> 0 then begin
      Application.MessageBox('NX^̓͒lɌ肪܂B','NX^', 0);
      exit;
    end;
    if (K < 2) or (K > 6) then begin
      Application.MessageBox('NX^͈̔͂͂QUłB','NX^', 0);
      exit;
    end;
    // f[^[ƃNX^[̊mF
    I := 0;
    for Y := 0 to GHeight - 1 do
      for X := 0 To GWidth - 1 do
        if ColorMat[Y, X] <> 0 then inc(I);
    if K > I then begin
      Application.MessageBox('NX^f[^[葽łB','NX^', 0);
      exit;
    end;
    setlength(cluster, K);
    setlength(SetCl,   K);
    X := GWidth  div K;
    Y := GHeight div K;
    // NX^̏ݒ
    // 摜ɑ΂čォEɌĎ΂߂ɓ̈ʒuɊt܂
    for I := 0 to K -1 do begin
      cluster[I].now_y := I * Y + Y div 2;
      cluster[I].now_x := I * X + X div 2;
      cluster[I].no    := 0;
      cluster[I].new_y := 0;
      cluster[I].new_x := 0;
      SetCl[I]         := -2;
    end;
    IM := 0;
    MinLeng := 0;
    // ݒ肳ꂽNX^[ʒuɑ΂Ĉԋ߂f[^[ʒuɃNX^[ʒuĐݒ
    for Loop := 0 to K - 1 do begin
      I  :=  0;                               // ʒuԍNA
      for Y := 0 to GHeight - 1 do begin
        for X := 0 To GWidth - 1 do begin
          if ColorMat[Y, X] <> 0 then begin
            // ɃNX^[ɎgpĂf[^[ʒumF
            SetClF := False;
            for ReNo := 0 to K - 1 do
              if I = SetCl[ReNo] then SetClF := True;
            // gpĂȂf[^[ʒu
            if not SetClF then  begin
              // ŏ̈ʒuݒ肳Ă
              if SetCl[Loop] = -1 then begin
                // f[^[ʒuƂ̋vZ
                nowLeng := dis(cluster[Loop].now_y, cluster[Loop].now_x, Y, X);
                // ݈ʒuÖʒu߂Vʒuۑ
                if MinLeng > nowLeng then begin
                  cluster[Loop].new_y := Y;   // Y ʒu
                  cluster[Loop].new_x := X;   // X ʒu
                  MinLeng := nowLeng;         // 
                  IM := I;                    // ʒuԍ
                end;
              end;
              // NX^[ʒuJnĂȂ
              if SetCl[Loop] = -2 then begin
                // ŏ̃f[^[ʒuƂ̋ݒ
                MinLeng := dis(cluster[Loop].now_y, cluster[Loop].now_x, Y, X);
                // ŏ̋ݒtOZbg
                SetCl[Loop] := -1;
              end;
            end;
          end;
          inc(I);                             // ʒuԍCNg
        end;
      end;
      SetCl[Loop] := IM;                      // ʒuԍZbg
      cluster[Loop].now_y := cluster[Loop].new_y;   // YʒuZbg
      cluster[Loop].now_x := cluster[Loop].new_x;   // XʒuZbg
      cluster[Loop].new_y := 0;                     // yWvpNA
      cluster[Loop].new_X := 0;                     // xWvpNA
    end;
  end;
  // s[g
  val(RepeatEdit.Text, ReNo, X);
  if X <> 0 then begin
    Application.MessageBox('s[g̓͒lɌ肪܂B','s[g', 0);
    exit;
  end;
  if (ReNo < 0) or (ReNo > 100) then begin
    Application.MessageBox('s[g̓[ȏɂĂB','s[g', 0);
    exit;
  end;
  // J[z̏
  for Y := 0 to GHeight - 1 do
    for X := 0 to GWidth - 1 do
      for I := 0 to 2 do
        OutMat[Y, X, I] := $FF;
  RepeatF := true;

  // w񐔃NX^[OvZ
  for Loop := 1 to ReNo do begin
    // SW`FbN
    for Y := 0 to GHeight - 1 do
      for X := 0 to GWidth - 1 do begin
        // 摜ԋ߂NX^[
        if ColorMat[Y, X] <> 0 then begin
          MinPos := 0;
          MinLeng := dis(cluster[0].now_y, cluster[0].now_x, Y, X);
          for I := 1 to K -1 do begin
            nowLeng := dis(cluster[I].now_y, cluster[I].now_x, Y, X);
            if MinLeng > nowLeng then begin
              MinPos := I;
              MinLeng := nowLeng;
            end;
          end;
          // ԋ߂NX^[̃JE^[CNg
          inc(cluster[MinPos].no);
          // W̍v߂܂
          cluster[MinPos].new_y := cluster[MinPos].new_y + Y;
          cluster[MinPos].new_x := cluster[MinPos].new_x + X;
          // F\邽߃CNg
          inc(MinPos);
          // MinPos̒lŐFZbg ̕@ł͂UF
          // F𑝂₷ꍇ́AHSLtoRGB gp
          if MinPos and $01 = $01 then OutMat[Y, X, 0] := $FF       // 
                                  else OutMat[Y, X, 0] := $00;
          if MinPos and $02 = $02 then OutMat[Y, X, 1] := $FF       // 
                                  else OutMat[Y, X, 1] := $00;
          if MinPos and $04 = $04 then OutMat[Y, X, 2] := $FF       // 
                                  else OutMat[Y, X, 2] := $00;
        end;
      end;
    // NX^[Y,YW̍vlƁAW̐畽ϒl߁ANX^[̐VWƂ܂B
    // ϒlvZJE^[ƍvl̓NA
    for I := 0 to K -1 do begin
      if cluster[I].no > 0 then begin
        cluster[I].now_y := cluster[I].new_y / cluster[I].no;
        cluster[I].now_x := cluster[I].new_x / cluster[I].no;
      end;
      cluster[I].no    := 0;
      cluster[I].new_y := 0;
      cluster[I].new_x := 0;
    end;
  end;

  // rbg}bvɐFz̒lZbg
  for Y := 0 to GHeight - 1 do begin
    PB := OutputBitmap.ScanLine[Y];
    for X := 0 To GWidth - 1 do begin
      PB[X].rgbtRed   := OutMat[Y, X, 0];
      PB[X].rgbtGreen := OutMat[Y, X, 1];
      PB[X].rgbtBlue  := OutMat[Y, X, 2];
    end;
  end;
  Imageout(OutputBitmap, 2, Scale);       // o͘gɕϔ{o
  Image2.Canvas.Brush.Style := bsSolid;
  Image2.Canvas.Brush.Color := clWhite;
  KMarks;                                 // NX^[̈ʒuە\
end;

//---------------------------------------------------
// t@C̃I[vƐFf[^[ϊ
//---------------------------------------------------
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  X, Y, D     : Integer;
  PBA         : PBytearray;
  PW          : integer;
begin
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute = true then                   // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        Image1.Width := GWidth;
        Image1.Height:= GHeight;
        Image1.Picture.Bitmap.SetSize(GWidth, GHeight);
        InputDBitmap.Width := GWidth;
        InputDBitmap.Height := GHeight;
        InputDBitmap.Canvas.Draw(0, 0, WIC);                  // rbg}bvɕ`tH[}bgϊ
        Image2.Picture.Bitmap.SetSize(GWidth, GHeight);
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else exit;
  OutputBitmap.Width  := GWidth;
  OutputBitmap.Height := GHeight;
  // pzm
  setLength(ColorMat, GHeight, GWidth);
  setLength(OutMat,   GHeight, GWidth, 3);
  // 摜邩SW`FbN
  for Y := 0 to Gheight - 1 do begin
    PBA := InputDBitmap.ScanLine[Y];
    for X := 0 to GWidth - 1 do begin
      PW := X * 3;
      D := PBA[PW] + PBA[PW + 1] + PBA[PW + 2];
      // NX^[WvZp摜z@摜͂Pɖꏊ͂OɃZbg܂
      if D < $FF * 3 then ColorMat[Y, X] := 1
                     else ColorMat[Y, X] := 0;
    end;
  end;
  // 摜\XP[ݒ
  scale := 485 / GWidth;
  if scale > 435 / GHeight then scale := 435 / GHeight;
  if scale <> 0 then DidScale := 1 / scale;
  scaleEdit.Text := FloatTostrF(scale, ffFixed, 5, 3);
  // ͉摜\
  Imageout(InputDBitmap, 1, scale);                           // o͘gɕϔ{o
  // {^
  KmeansBtn.Enabled := True;
  // NX^[vZtOZbg
  RepeatF := False;
  MSetF := -3;
end;

//------------------------------
// 摜̃t@Cւ̕ۑ
//------------------------------
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                            // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');   // gq̐ݒ
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');   // gq̐ݒ
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');   // gq̐ݒ
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');   // gq̐ݒ
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');   // gq̐ݒ
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                         // gqo
  if not WFormatSet then begin                                             // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                      // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                          // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                 // TWicImage
  try
    WIC.Assign(OutputBitmap);                                              // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                               // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                 // t@C̏o
  finally
    WIC.Free;                                                              // TWicImage
  end;
end;

//----------------
// ݒ
//----------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  Height := 496;
  Width  := 1136;
  Timer1.Enabled := False;
  Image1.Width  := ImageHWC div 2;
  Image1.Height := ImageHWC div 2;
  ScrollBox1.Left := 8;
  ScrollBox1.Height := ImageHWC;
  ScrollBox1.Width  := 490;
  Image1.Top := 0;
  Image1.Left := 0;
  Image2.Width  := ImageHWC div 2;
  Image2.Height := ImageHWC div 2;
  ScrollBox2.Left := 512;
  ScrollBox2.Height := ImageHWC;
  ScrollBox2.Width  := 490;
  Image2.Top := 0;
  Image2.Left := 0;
  InputDBitmap  := TBitmap.Create;
  OutputBitmap  := TBitmap.Create;
  InputDBitmap.PixelFormat := pf24bit;
  OutputBitmap.PixelFormat := pf24bit;
  KMeansBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
  Scale := 1;
  MSetF := -3;
end;

//----------------
// I
//----------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputDBitmap.Free;
  OutputBitmap.Free;
end;


end.
